﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class Gameplay : MonoBehaviour {

    public CollisionScript thiscollisionscript;
    GameObject GrowingSphere;
    RaycastHit[] hits;

    public GameObject Space;
    Vector3 SpaceStartPos;

    public float Oxygen = 1f;
    public int Fuel = 10;
    public Text FuelText;
    public float OxygenDecreaseFactor;
    public Slider OxygenSlider;
    public Text OxygenText;

    public bool GameOver = true;
    bool startGameOverTimer = false;
    float gameovertimer =0f;

    public float Highscore = 0f;
    public Text HighscoreText;

    public AudioClip Wave;
    AudioSource myaudiosource;
    public GameObject GameOverPanel;
    //public float maxSpeed = 0.1f;//Replace with your max speed

    public Rigidbody Player;
    
    // Use this for initialization
    void Start () {
        GrowingSphere = Resources.Load("Collider", typeof(GameObject)) as GameObject;
        FuelText.text = Fuel.ToString();
        SpaceStartPos = Space.transform.position;
        myaudiosource = this.gameObject.GetComponent<AudioSource>();
    }

    public void IncreaseFuel(int value)
    {
        Fuel += value;
        FuelText.text = Fuel.ToString();
    }

    public void IncreaseOxygen(float value)
    {
        Oxygen += value;
        if (Oxygen > 1)
            Oxygen = 1f;
    }

    void GameOverNow()
    {
        SceneManager.LoadScene(0);
    }
    // Update is called once per frame
    void Update()
    {
        if (GameOver)
            return;
        /*if (Player.velocity.magnitude >= maxSpeed)
        {
            Player.velocity = Player.velocity.normalized * maxSpeed;
        }*/

        Highscore += Time.deltaTime;
        HighscoreText.text = Mathf.Floor(Highscore / 60).ToString("00") + ":" + Mathf.Floor(Highscore % 60).ToString("00");


        if (startGameOverTimer)
        {
            gameovertimer += Time.deltaTime;
            if (gameovertimer >= 3)
            {
                if (Fuel >= 1)
                {
                    gameovertimer = 0f;
                    startGameOverTimer = false;
                } else
                {
                    GameOverNow();
                }

            }
            

        }

        Oxygen -= (Time.deltaTime * OxygenDecreaseFactor);
        if (Oxygen < 0)
        {
            Oxygen = 0;
            GameOverNow();
        }
        OxygenSlider.value = Oxygen;
        OxygenText.text = Mathf.RoundToInt(Oxygen*100).ToString() + "%";
        if (Input.GetButtonDown("Fire1"))
        {
            Ray vRay = Camera.main.ScreenPointToRay(Input.mousePosition);

            hits = Physics.RaycastAll(vRay, 1000.0F);
            for (int i = 0; i < hits.Length; i++)
            {
                RaycastHit hit = hits[i];
               // Debug.Log("Click hits: " + hit.collider.name);
                if (hit.transform.tag == "Water" && Fuel >= 1)
                {
                    --Fuel;
                    FuelText.text = Fuel.ToString();
                    thiscollisionscript.Addimpact(hit.point);
                    Instantiate(GrowingSphere, new Vector3(hit.point.x, hit.point.y, hit.point.z), Quaternion.identity);
                    myaudiosource.PlayOneShot(Wave);
                }
                if (Fuel <= 0)
                {
                    startGameOverTimer = true;
                }

            }
        }

            
        
    }
}
