﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ShipScript : MonoBehaviour {

    Vector3 prevpos = new Vector3(0,0,0);
    Vector3 newpos = new Vector3(0, -17.4f, 0);
    //Vector3 curpos;
    float xDiff;
    float zDiff;
    public Renderer rippleRenderer;
    AudioSource myAudioSource;
    public List<Transform> Targets;

    public AudioClip[] VoiceSounds = new AudioClip[5];

    float dabtimer = 0f;
    bool dabbing = false;

    //bool closeby = false;

    int Framecounter = 0;
    public Animator CharAnimator;

    public bool startwave = true;
    public float maxSpeed = 40f;//Replace with your max speed
    Rigidbody myRigidbody;
    // Use this for initialization
    void Start () {
        prevpos =  this.transform.position;
        targetCamPos = newpos = Camera.main.transform.position;
        myAudioSource = GetComponent<AudioSource>();
        rippleRenderer = GameObject.Find("ripplewater").GetComponent<Renderer>();
        /* foreach (Transform child in GameObject.Find("Space").transform)
         {
             if (child.name != "Ship" && !child.name.Contains("planet"))
             Targets.Add(child);
         }*/
        myRigidbody = this.transform.GetComponent<Rigidbody>();
        camToShipOffset = Camera.main.transform.position - this.transform.position;
    }

    public void PlayRandomAlienSound()
    {
        myAudioSource.PlayOneShot(VoiceSounds[Random.Range(1,5)]);
    }
    public void PlayAlienHiSound()
    {
        myAudioSource.PlayOneShot(VoiceSounds[0]);
    }


    public void RemoveTarget(GameObject thistarget)
    {
        Targets.Remove(thistarget.transform);
    }
    float xFactor = 0.0042f;
    float zFactor = 0.0042f;

    Vector3 camToShipOffset;
    Vector3 targetCamPos;

    public AudioClip[] alienvoices = new AudioClip[6];
    // Update is called once per frame
    void Update()
    {

        //  Camera.main.transform.position += (this.transform.position - prevpos);
        if (startwave)
            return;


        xDiff = this.transform.position.x - prevpos.x;
        zDiff = this.transform.position.z - prevpos.z;
        newpos.x = newpos.x + xDiff;
        newpos.z = newpos.z + zDiff;
        //Debug.Log(xDiff + "   " + zDiff);


        Camera.main.transform.position = Vector3.Lerp(Camera.main.transform.position, newpos, Time.deltaTime * 30f); 
        rippleRenderer.material.SetTextureOffset("_MainTex", new Vector2(-Camera.main.transform.position.x * xFactor, -Camera.main.transform.position.z * zFactor));
        //prevpos.y = 0f;
        prevpos = this.transform.position;


        ++Framecounter;
        if (Framecounter >= 60) { 

            if (dabbing)
            {
                dabtimer += Time.deltaTime;
                if (dabtimer >= 4)
                {
                    //closeby = false;
                    dabtimer = 0f;
                    dabbing = false;
                }
                return;
            }

            Transform closestEnemy = GetClosestEnemy();
            if (closestEnemy == null)
                return;

            Vector3 pos = this.transform.position;
            Vector3 dir = -(this.transform.position - closestEnemy.position).normalized;
            // Debug.DrawLine(pos, pos + dir * 10, Color.red, Mathf.Infinity);
            // Debug.Log(dir);
            float dist = Vector3.Distance(this.transform.position, closestEnemy.position);
            if (dist <= 50f)
            {
                CharAnimator.SetTrigger("yes");
                return;
            }
            else if (dist > 1500f)
            {
                CharAnimator.SetTrigger("no");
                return;
            }

            if (dir.x >= 0f && Mathf.Abs(dir.x) > Mathf.Abs(dir.z))    // dir.z < 0.5f && dir.z > -0.5f)
                CharAnimator.SetTrigger("right");
            else if (dir.x < 0f && Mathf.Abs(dir.x) > Mathf.Abs(dir.z))
                CharAnimator.SetTrigger("left");
            if (dir.z >= -0f && Mathf.Abs(dir.z) > Mathf.Abs(dir.x))
                CharAnimator.SetTrigger("up");
            if (dir.z < -0f && Mathf.Abs(dir.z) > Mathf.Abs(dir.x))
                CharAnimator.SetTrigger("down");

            Framecounter = 0;
        }



    }

    private void FixedUpdate()
    {
        this.GetComponent<Rigidbody>().velocity = Vector3.ClampMagnitude(this.GetComponent<Rigidbody>().velocity, maxSpeed);
    }

    Transform GetClosestEnemy ()
    {
        Transform bestTarget = null;
        float closestDistanceSqr = Mathf.Infinity;
        Vector3 currentPosition = transform.position;
        foreach (Transform potentialTarget in Targets)
        {
            Vector3 directionToTarget = potentialTarget.position - currentPosition;
            float dSqrToTarget = directionToTarget.sqrMagnitude;
            if (dSqrToTarget < closestDistanceSqr)
            {
                closestDistanceSqr = dSqrToTarget;
                bestTarget = potentialTarget;
            }
        }
       //Debug.Log("Closet Enemy is: " + bestTarget.name);
        return bestTarget;
    }

    

    public void OnPickUpTarget()
    {
        myAudioSource.Play();
        dabbing = true;
    }

    void OnCollisionEnter(Collision collision)  //Plays Sound Whenever collision detected
    {
        Debug.Log(collision);
        if (collision.transform.tag == "Player")
        {
            Debug.Log("Hit");
        }
    }
}
