﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class TargetScript : MonoBehaviour {

   // public Material empty;
    //public Material filled;

    public enum Type { Fuel, Oxygen };
    public Type ThisType;
    Animator myAnimator;
    public int FuelAmount = 5;
    public float OxygenAmount = 0.2f;

    public float distanceToShip;
    GameObject Player;
    Gameplay GameplayScript;
    AudioSource myAudioSource;
    // Use this for initialization
    void Start () {
        Player = GameObject.Find("Ship");
        myAudioSource = GetComponent<AudioSource>();
        GameplayScript = Camera.main.gameObject.GetComponent<Gameplay>();
        myAnimator = this.transform.FindChild("TagPlane").GetComponent<Animator>();
    }

    // Update is called once per frame
    void Update () {
        distanceToShip = Vector3.Distance(transform.position, Player.transform.position);
        if (distanceToShip > 100)
            distanceToShip = 100f;


        myAudioSource.pitch =  100 / distanceToShip;

        myAnimator.speed = 50 / distanceToShip;
    }

    void OnTriggerEnter(Collider Other)
    {
        if (Other.tag == "Player" && ThisType == Type.Oxygen)
        {
            Player.GetComponent<ShipScript>().OnPickUpTarget();
            //this.GetComponent<MeshRenderer>().material = filled;
            GameplayScript.IncreaseOxygen(OxygenAmount);
            Player.GetComponent<ShipScript>().RemoveTarget(this.gameObject);
            Player.GetComponent<ShipScript>().PlayRandomAlienSound();
            myAnimator.SetTrigger("Close");
            this.gameObject.GetComponent<SphereCollider>().enabled = false;
            this.gameObject.GetComponent<AudioSource>().enabled = false;
            // DestroyObject(this.gameObject);
        } else if (Other.tag == "Player" && ThisType == Type.Fuel)
        {
            Player.GetComponent<ShipScript>().OnPickUpTarget();
            //this.GetComponent<MeshRenderer>().material = filled;
            Player.GetComponent<ShipScript>().RemoveTarget(this.gameObject);
            Player.GetComponent<ShipScript>().PlayRandomAlienSound();

            myAnimator.SetTrigger("Close");
            this.gameObject.GetComponent<SphereCollider>().enabled = false;
            this.gameObject.GetComponent<AudioSource>().enabled = false;
            GameplayScript.IncreaseFuel(FuelAmount);
           // DestroyObject(this.gameObject);
        }

    }

    void OnTriggerExit(Collider Other)
    {
        if (Other.tag == "Player")
        {
           // this.GetComponent<MeshRenderer>().material = empty;
        }

    }
}
